unit uCadAgenda;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Unit1, ImgList, IWImageList, Menus, IWHTMLControls, IWCompLabel,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWCompMenu,
  IWCompListbox, IWDBStdCtrls, DB, IWCompMemo, IWCompEdit, IWCompButton,
  IWAppForm;

type
  TfrmCadAgenda = class(TfrmBase)
    IWLabel3: TIWLabel;
    cmbUsuario: TIWDBComboBox;
    dsAgenda: TDataSource;
    cmbSituacao: TIWDBComboBox;
    IWLabel4: TIWLabel;
    IWLabel5: TIWLabel;
    IWLabel6: TIWLabel;
    edtDataIni: TIWDBEdit;
    edtDataFim: TIWDBEdit;
    IWLabel7: TIWLabel;
    cmbTipo: TIWDBComboBox;
    IWLabel8: TIWLabel;
    IWDBMemo1: TIWDBMemo;
    bGravar: TIWButton;
    bCancelar: TIWButton;
    procedure IWAppFormCreate(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bGravarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCadAgenda: TfrmCadAgenda;

implementation

uses ServerController, UserSessionUnit, uAgenda;

{$R *.dfm}

procedure TfrmCadAgenda.IWAppFormCreate(Sender: TObject);
begin
  inherited;
  //testa se  incluso ou alterao, para ajustar o ttulo
  if UserSession.OperacaoAgenda = 'I' then
  begin
    IWLabel1.Caption := 'Incluso de Compromisso - Agenda On-Line ';
    //sendo incluso, elimina a opo "Concludo" do IWDBComboBox, pois
    //no  possvel se incluir um agendamento concludo
    cmbSituacao.Items.Delete(cmbSituacao.Items.IndexOf('Concludo'));
  end
  else if UserSession.OperacaoAgenda = 'A' then
    IWLabel1.Caption := 'Alterao de Compromisso - Agenda On-Line ';

  //assim como no onCreate do frmAgenda, carrega no respectivo IWDBComboBox
  //os usurios cadastrados
  if not UserSession.cdsUsuarios.Active then
    UserSession.cdsUsuarios.Open;
  UserSession.cdsUsuarios.IndexFieldNames := 'NOMUSU';
  UserSession.cdsUsuarios.First;
  while not UserSession.cdsUsuarios.eof do
  begin
    cmbUsuario.Items.Add(UserSession.cdsUsuariosNOMUSU.Value + '=' +
        UserSession.cdsUsuariosCODUSU.AsAnsiString);
    UserSession.cdsUsuarios.Next;
  end;
  UserSession.cdsUsuarios.Close;
  UserSession.cdsUsuarios.IndexFieldNames := '';

  //Carrega no respectivo IWDBComboBox os Tipos de Agendamentos cadastradosS
  if not UserSession.cdsTiposAgenda.Active then
    UserSession.cdsTiposAgenda.Open;
  UserSession.cdsTiposAgenda.IndexFieldNames := 'NOMTIP';
  UserSession.cdsTiposAgenda.First;
  while not UserSession.cdsTiposAgenda.eof do
  begin
    cmbTipo.Items.Add(UserSession.cdsTiposAgendaNOMTIP.Value + '=' +
        UserSession.cdsTiposAgendaCODTIP.AsAnsiString);
    UserSession.cdsTiposAgenda.Next;
  end;
  UserSession.cdsTiposAgenda.Close;
  UserSession.cdsTiposAgenda.IndexFieldNames := '';
end;

procedure TfrmCadAgenda.bGravarClick(Sender: TObject);
begin
  inherited;
  if UserSession.cdsAgenda.ApplyUpdates(0) <> 0 then
    raise Exception.Create('Erro ao gravar o compromisso no banco de dados')
  else
  begin
    TIWAppForm(WebApplication.ActiveForm).Release;
    TfrmAgenda.Create(WebApplication).Show;
  end;
end;

procedure TfrmCadAgenda.bCancelarClick(Sender: TObject);
begin
  inherited;
  UserSession.OperacaoAgenda := #0;
  UserSession.cdsAgenda.Cancel;
  TIWAppForm(WebApplication.ActiveForm).Release;
  TfrmAgenda.Create(WebApplication).Show;
end;

end.
