unit FAddIngrediente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils, Math, uDBConfiguration, FIngrediente;

type
  TfrmAddIngrediente = class(TForm)
    lblIngrediente: TLabel;
    cmbIngrediente: TComboBox;
    Label1: TLabel;
    edtQtde: TEdit;
    btnSalvar: TButton;
    btnNovo: TButton;
    procedure btnSalvarClick(Sender: TObject);
    procedure edtQtdeKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
  private
    oLstIngredientes, oLstUnidades, oLstID : TStringList;
  public
    procedure Execute(out aIngrediente, aUnidade : string; out aQtde : Double; out aID : string);
  end;

var
  frmAddIngrediente: TfrmAddIngrediente;

implementation

{$R *.dfm}

procedure TfrmAddIngrediente.btnNovoClick(Sender: TObject);
begin
  frmIngrediente := TfrmIngrediente.Create(nil);
  try
    frmIngrediente.ShowModal;
    cmbIngrediente.Items.Clear;
    oLstIngredientes.Clear;
    oLstUnidades.Clear;
    oLstID.Clear;
    TDBConfig.GetInstance.SearchIngForCombo(oLstIngredientes, oLstUnidades, oLstID);
    cmbIngrediente.Items.Text := oLstIngredientes.Text;
  finally
    FreeAndNil(frmIngrediente);
  end;
end;

procedure TfrmAddIngrediente.btnSalvarClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmAddIngrediente.edtQtdeKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', Chr(8), ',']) then begin
    Key := #0;
  end;
end;

procedure TfrmAddIngrediente.Execute(out aIngrediente, aUnidade: string; out aQtde: Double; out aID : string);
begin
  Self.ShowModal;
  aQtde := StrToFloatDef(edtQtde.Text, 0);
  aIngrediente := cmbIngrediente.Text;
  aUnidade := oLstUnidades[cmbIngrediente.ItemIndex];
  aID := oLstID[cmbIngrediente.ItemIndex];
end;

procedure TfrmAddIngrediente.FormCreate(Sender: TObject);
begin
  oLstIngredientes := TStringList.Create;
  oLstUnidades := TStringList.Create;
  oLstID := TStringList.Create;
end;

procedure TfrmAddIngrediente.FormDestroy(Sender: TObject);
begin
  oLstIngredientes.Destroy;
  oLstUnidades.Destroy;
  oLstID.Destroy;
end;

procedure TfrmAddIngrediente.FormShow(Sender: TObject);
begin
  TDBConfig.GetInstance.SearchIngForCombo(oLstIngredientes, oLstUnidades, oLstID);
  cmbIngrediente.Items.Text := oLstIngredientes.Text;
end;

end.
